local mod = ...



-- Building Asset Processor -------------------------------------------------------------------------------------
mod:registerAssetProcessor("models/MarketCart1.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })



-- Assets -------------------------------------------------------------------------------------
mod:registerAssetId("models/MarketCart1.fbx/Prefab/BerryCartPart", "PREFAB_MARKETCART_BERRY")
mod:registerAssetId("models/MarketCart1.fbx/Prefab/BreadCartPart", "PREFAB_MARKETCART_BREAD")
mod:registerAssetId("models/MarketCart1.fbx/Prefab/CheeseCartPart", "PREFAB_MARKETCART_CHEESE")
mod:registerAssetId("models/MarketCart1.fbx/Prefab/FishCartPart", "PREFAB_MARKETCART_FISH")
mod:registerAssetId("models/MarketCart1.fbx/Prefab/HoneyCartPart", "PREFAB_MARKETCART_HONEY")



-- Paths: Berry Cart
mod:registerAssetId("models/MarketCart1.fbx/Prefab/BerryCartPart/PATH_A_1", "PATH_MARKETCART_BERRY1")
mod:registerAssetId("models/MarketCart1.fbx/Prefab/BerryCartPart/PATH_B_1", "PATH_MARKETCART_BERRY2")
mod:registerAssetId("models/MarketCart1.fbx/Prefab/BerryCartPart/PATH_C_1", "PATH_MARKETCART_BERRY3")
mod:registerAssetId("models/MarketCart1.fbx/Prefab/BerryCartPart/PATH_D_1", "PATH_MARKETCART_BERRY4")

mod:registerPrefabComponent("models/MarketCart1.fbx/Prefab/BerryCartPart", {
    DataType = "COMP_BUILDING_PART",
    PathList = {
        {
            PathType = BUILDING_PATH_TYPE.DEFAULT,
            WayPointList = { "PATH_MARKETCART_BERRY1" }
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = { "PATH_MARKETCART_BERRY2" }
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = { "PATH_MARKETCART_BERRY3" }
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = { "PATH_MARKETCART_BERRY4" }
        },
    }
})



-- Paths: Bread Cart
mod:registerAssetId("models/MarketCart1.fbx/Prefab/BreadCartPart/PATH_I_1", "PATH_MARKETCART_BREAD1")
mod:registerAssetId("models/MarketCart1.fbx/Prefab/BreadCartPart/PATH_J_1", "PATH_MARKETCART_BREAD2")
mod:registerAssetId("models/MarketCart1.fbx/Prefab/BreadCartPart/PATH_K_1", "PATH_MARKETCART_BREAD3")
mod:registerAssetId("models/MarketCart1.fbx/Prefab/BreadCartPart/PATH_L_1", "PATH_MARKETCART_BREAD4")

mod:registerPrefabComponent("models/MarketCart1.fbx/Prefab/BreadCartPart", {
    DataType = "COMP_BUILDING_PART",
    PathList = {
        {
            PathType = BUILDING_PATH_TYPE.DEFAULT,
            WayPointList = { "PATH_MARKETCART_BREAD1" }
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = { "PATH_MARKETCART_BREAD2" }
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = { "PATH_MARKETCART_BREAD3" }
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = { "PATH_MARKETCART_BREAD4" }
        },
    }
})



-- Paths: Cheese Cart
mod:registerAssetId("models/MarketCart1.fbx/Prefab/CheeseCartPart/PATH_M_1", "PATH_MARKETCART_CHEESE1")
mod:registerAssetId("models/MarketCart1.fbx/Prefab/CheeseCartPart/PATH_N_1", "PATH_MARKETCART_CHEESE2")
mod:registerAssetId("models/MarketCart1.fbx/Prefab/CheeseCartPart/PATH_O_1", "PATH_MARKETCART_CHEESE3")
mod:registerAssetId("models/MarketCart1.fbx/Prefab/CheeseCartPart/PATH_P_1", "PATH_MARKETCART_CHEESE4")

mod:registerPrefabComponent("models/MarketCart1.fbx/Prefab/CheeseCartPart", {
    DataType = "COMP_BUILDING_PART",
    PathList = {
        {
            PathType = BUILDING_PATH_TYPE.DEFAULT,
            WayPointList = { "PATH_MARKETCART_CHEESE1" }
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = { "PATH_MARKETCART_CHEESE2" }
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = { "PATH_MARKETCART_CHEESE3" }
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = { "PATH_MARKETCART_CHEESE4" }
        },
    }
})



-- Paths: Fish Cart
mod:registerAssetId("models/MarketCart1.fbx/Prefab/FishCartPart/PATH_E_1", "PATH_MARKETCART_FISH1")
mod:registerAssetId("models/MarketCart1.fbx/Prefab/FishCartPart/PATH_F_1", "PATH_MARKETCART_FISH2")
mod:registerAssetId("models/MarketCart1.fbx/Prefab/FishCartPart/PATH_G_1", "PATH_MARKETCART_FISH3")
mod:registerAssetId("models/MarketCart1.fbx/Prefab/FishCartPart/PATH_H_1", "PATH_MARKETCART_FISH4")

mod:registerPrefabComponent("models/MarketCart1.fbx/Prefab/FishCartPart", {
    DataType = "COMP_BUILDING_PART",
    PathList = {
        {
            PathType = BUILDING_PATH_TYPE.DEFAULT,
            WayPointList = { "PATH_MARKETCART_FISH1" }
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = { "PATH_MARKETCART_FISH2" }
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = { "PATH_MARKETCART_FISH3" }
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = { "PATH_MARKETCART_FISH4" }
        },
    }
})



-- Paths: Honey Cart
mod:registerAssetId("models/MarketCart1.fbx/Prefab/HoneyCartPart/PATH_Q_1", "PATH_MARKETCART_HONEY1")
mod:registerAssetId("models/MarketCart1.fbx/Prefab/HoneyCartPart/PATH_R_1", "PATH_MARKETCART_HONEY2")
mod:registerAssetId("models/MarketCart1.fbx/Prefab/HoneyCartPart/PATH_S_1", "PATH_MARKETCART_HONEY3")
mod:registerAssetId("models/MarketCart1.fbx/Prefab/HoneyCartPart/PATH_T_1", "PATH_MARKETCART_HONEY4")

mod:registerPrefabComponent("models/MarketCart1.fbx/Prefab/HoneyCartPart", {
    DataType = "COMP_BUILDING_PART",
    PathList = {
        {
            PathType = BUILDING_PATH_TYPE.DEFAULT,
            WayPointList = { "PATH_MARKETCART_HONEY1" }
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = { "PATH_MARKETCART_HONEY2" }
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = { "PATH_MARKETCART_HONEY3" }
        },
        {
            PathType = BUILDING_PATH_TYPE.PICKUP,
            WayPointList = { "PATH_MARKETCART_HONEY4" }
        },
    }
})



-- Particle: Honey Cart bees -------------------------------------------------------------------------------------
mod:registerPrefabComponent("models/MarketCart1.fbx/Prefab/HoneyCartPart/BeeEmitter", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "PARTICLE_SYSTEM_BEEKEEPER_BEES",
	IsPlaying = true,
	IsEmitting = true
})

mod:registerPrefabComponent("models/MarketCart1.fbx/Prefab/HoneyCartPart/BeeEmitter", {
	DataType = "COMP_PARTICLE_EMITTER_TOGGLE",
	Enabled = false
})



-- If Fuel is loaded, add the fuelmonger cart
if (foundation.isModLoaded("7b6dabf2-3523-46ff-ba47-caca86189784")) then
    mod:override({
        Id = "FUELCART_PART",
        Name = "FUELCART_NAME"
    })
    mod:override({
        Id = "MONUMENT_MARKET",
        BuildingPartSetList = {
            Action = "APPEND",
            {
                Name = "GENERAL",
                BuildingPartList = { 
                    "FUELCART_PART",
                }
            },
        }
    })
end



-- If Security is loaded, add the Town Crier
if (foundation.isModLoaded("99ee3b3b-f103-41f0-a725-bc466a2fc6de")) then
    mod:override({
        Id = "MONUMENT_MARKET",
        BuildingPartSetList = {
            Action = "APPEND",
            {
                Name = "GENERAL",
                BuildingPartList = { 
                    "BUILDING_PART_SECURITY_CRIER1",
                }
            },
        }
    })
end



-- Building: Market (Override) -------------------------------------------------------------------------------------
mod:override({
    Id = "MONUMENT_MARKET",
	RequiredPartList = {},
	BuildingPartSetList = {
        Action = "APPEND",
		{
			Name = "GENERAL",
			BuildingPartList = { 
				"BUILDING_PART_MARKETCART_BERRY",
				"BUILDING_PART_MARKETCART_BREAD",
				"BUILDING_PART_MARKETCART_CHEESE",
				"BUILDING_PART_MARKETCART_FISH",
				"BUILDING_PART_MARKETCART_HONEY",
			}
		},
    }
})



-- If Vegetable and Poultry is loaded, add the carts
if (foundation.isModLoaded("fe9d3810-8afc-40e5-9fc9-bdbd3421e8cb")) then
    mod:override({
        Id = "MONUMENT_MARKET",
        BuildingPartSetList = {
            Action = "APPEND",
            {
                Name = "GENERAL",
                BuildingPartList = { 
                    "POULTRYCART_PART",
                    "POULTRYCART_EGG_PART",
                    "VEGETABLECART_PART",
                }
            },
        }
    })
end



-- If Livestock is loaded, add the carts and tables
if (foundation.isModLoaded("debb69c1-eb38-4183-9739-fbafa47568b4")) then
    mod:override({ Id = "BUILDING_PART_LIVESTOCK_CREAMERY_TABLE", Name = "BUILDING_PART_LIVESTOCK_CREAMERYTABLE_NAME" })
    mod:override({ Id = "BUTCHERSHOP_COUNTER_PART", Name = "BUILDING_PART_LIVESTOCK_BUTCHERTABLE_NAME" })
    mod:override({ Id = "CHANDLER_COUNTER_PART", Name = "BUILDING_PART_LIVESTOCK_CHANDLERTABLE_NAME" })
    mod:override({
        Id = "MONUMENT_MARKET",
        BuildingPartSetList = {
            Action = "APPEND",
            {
                Name = "GENERAL",
                BuildingPartList = { 
                    "MILKCART_PART",
                    "BUILDING_PART_LIVESTOCK_CREAMERY_TABLE",
                    "BUTCHERSHOP_COUNTER_PART",
                    "CHANDLER_COUNTER_PART",
                }
            },
        }
    })
end



-- If Orchard is loaded, add the apple cart
if (foundation.isModLoaded("f252f14d-ca1d-4d02-97ca-46581d4b567d")) then
    mod:override({
        Id = "MONUMENT_MARKET",
        BuildingPartSetList = {
            Action = "APPEND",
            {
                Name = "GENERAL",
                BuildingPartList = { 
                    "BUILDING_PART_ORCHARD_CART",
                }
            },
        }
    })
end



-- If Furniture is loaded, add the table
if (foundation.isModLoaded("4a8d3ff2-60af-4c75-8950-33e990975862")) then
    mod:override({
        Id = "MONUMENT_MARKET",
        BuildingPartSetList = {
            Action = "APPEND",
            {
                Name = "GENERAL",
                BuildingPartList = { 
                    "JOINERWORKSHOPCOUNTER_PART",
                }
            },
        }
    })
end



-- If Basic Materials is loaded, add the pottery cart
if (foundation.isModLoaded("d757c3ab-0148-4290-aa51-5559329f5640")) then
    mod:override({
        Id = "MONUMENT_MARKET",
        BuildingPartSetList = {
            Action = "APPEND",
            {
                Name = "GENERAL",
                BuildingPartList = { 
                    "BUILDING_PART_BASIC_POTTERCART",
                }
            },
        }
    })
end




-- Building Part: Berry Cart -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_MARKETCART_BERRY",
    Name = "BUILDING_PART_MARKETCART_BERRY_NAME", 
    Category = "MARKET_TABLE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_MARKETCART_BERRY"
	},
	BuildingZone = { 
		ZoneEntryList = {
			{ 
				Polygon = polygon.createRectangle( {1, 1}, {0, 0} ),
				Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_MARKETCART_BERRY",
	Cost = {
        BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 1 } },
        UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 1 } },
        RessourcesNeeded = {
            { Resource = "PLANK", Quantity = 2 },
		}
	}
})



-- Building Part: Bread Cart -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_MARKETCART_BREAD",
	Name = "BUILDING_PART_MARKETCART_BREAD_NAME", 
    Category = "MARKET_TABLE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_MARKETCART_BREAD"
	},
	BuildingZone = { 
		ZoneEntryList = {
			{ 
				Polygon = polygon.createRectangle( {1, 1}, {0, 0} ),
				Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_MARKETCART_BREAD",
	Cost = {
        BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 1 } },
        UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 1 } },
        RessourcesNeeded = {
            { Resource = "PLANK", Quantity = 2 },
		}
	}
})



-- Building Part: Cheese Cart -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_MARKETCART_CHEESE",
	Name = "BUILDING_PART_MARKETCART_CHEESE_NAME", 
    Category = "MARKET_TABLE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_MARKETCART_CHEESE"
	},
	BuildingZone = { 
		ZoneEntryList = {
			{ 
				Polygon = polygon.createRectangle( {1, 1}, {0, 0} ),
				Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_MARKETCART_CHEESE",
	Cost = {
        BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 1 } },
        UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 1 } },
        RessourcesNeeded = {
            { Resource = "PLANK", Quantity = 2 },
		}
	}
})



-- Building Part: Fish Cart -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_MARKETCART_FISH",
	Name = "BUILDING_PART_MARKETCART_FISH_NAME", 
    Category = "MARKET_TABLE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_MARKETCART_FISH"
	},
	BuildingZone = { 
		ZoneEntryList = {
			{ 
				Polygon = polygon.createRectangle( {1, 1}, {0, 0} ),
				Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_MARKETCART_FISH",
	Cost = {
        BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 1 } },
        UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 1 } },
        RessourcesNeeded = {
            { Resource = "PLANK", Quantity = 2 },
		}
	}
})



-- Building Part: Honey Cart -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_MARKETCART_HONEY",
	Name = "BUILDING_PART_MARKETCART_HONEY_NAME", 
    Category = "MARKET_TABLE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_MARKETCART_HONEY"
	},
	BuildingZone = { 
		ZoneEntryList = {
			{ 
				Polygon = polygon.createRectangle( {1, 1}, {0, 0} ),
				Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_MARKETCART_HONEY",
	Cost = {
        BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 1 } },
        UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 1 } },
        RessourcesNeeded = {
            { Resource = "PLANK", Quantity = 2 },
		}
	}
})




-- Building Function: Berry Cart -------------------------------------------------------------------------------------
mod:registerEnumValue( "RESOURCE_TYPE", "RESOURCE_TYPE_BERRY" )
mod:override({ Id = "BERRIES", ResourceTypeList = { "RESOURCE_FOOD", "FOOD", "RESOURCE_TYPE_BERRY" } })
mod:register({
    DataType = "BUILDING_FUNCTION_MARKET",
    Id = "BUILDING_FUNCTION_MARKETCART_BERRY",
	Name = "BUILDING_FUNCTION_MARKETCART_BERRY_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "MARKET_TENDER", 
        Behavior = "BEHAVIOR_WORK"
    },
	TypeList = { "RESOURCE_TYPE_BERRY" },
	IsOverrideCapacity = true,
	CapacityPerSlot = 50,
	InputInventoryCapacity = {
		{ Resource = "BERRIES", Quantity = 50 },
	},
    ResourceListNeeded = {
		{ Resource = "BERRIES", Quantity = 10 },
	},
	ResourceProduced = {
		{ Resource = "BERRIES", Quantity = 10 },
	}
})



-- Building Function: Bread Cart -------------------------------------------------------------------------------------
mod:registerEnumValue( "RESOURCE_TYPE", "RESOURCE_TYPE_BREAD" )
mod:override({ Id = "BREAD", ResourceTypeList = { "FOOD", "RESOURCE_TYPE_BREAD" } })
mod:register({
    DataType = "BUILDING_FUNCTION_MARKET",
    Id = "BUILDING_FUNCTION_MARKETCART_BREAD",
	Name = "BUILDING_FUNCTION_MARKETCART_BREAD_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "MARKET_TENDER", 
        Behavior = "BEHAVIOR_WORK"
    },
	TypeList = { "RESOURCE_TYPE_BREAD" },
	IsOverrideCapacity = true,
	CapacityPerSlot = 50,
	InputInventoryCapacity = {
		{ Resource = "BREAD", Quantity = 50 },
	},
    ResourceListNeeded = {
		{ Resource = "BREAD", Quantity = 10 },
	},
	ResourceProduced = {
		{ Resource = "BREAD", Quantity = 10 },
	}
})



-- Building Function: Cheese Cart -------------------------------------------------------------------------------------
mod:registerEnumValue( "RESOURCE_TYPE", "RESOURCE_TYPE_CHEESE" )
mod:override({ Id = "CHEESE", ResourceTypeList = { "RESOURCE_FOOD", "FOOD", "RESOURCE_TYPE_CHEESE" } })
mod:register({
    DataType = "BUILDING_FUNCTION_MARKET",
    Id = "BUILDING_FUNCTION_MARKETCART_CHEESE",
	Name = "BUILDING_FUNCTION_MARKETCART_CHEESE_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "MARKET_TENDER", 
        Behavior = "BEHAVIOR_WORK"
    },
	TypeList = { "RESOURCE_TYPE_CHEESE" },
	IsOverrideCapacity = true,
	CapacityPerSlot = 50,
	InputInventoryCapacity = {
		{ Resource = "CHEESE", Quantity = 50 },
	},
    ResourceListNeeded = {
		{ Resource = "CHEESE", Quantity = 10 },
	},
	ResourceProduced = {
		{ Resource = "CHEESE", Quantity = 10 },
	}
})



-- Building Function: Fish Cart -------------------------------------------------------------------------------------
mod:registerEnumValue( "RESOURCE_TYPE", "RESOURCE_TYPE_FISH" )
mod:override({ Id = "FISH", ResourceTypeList = { "FOOD", "RESOURCE_TYPE_FISH" } })
mod:register({
    DataType = "BUILDING_FUNCTION_MARKET",
    Id = "BUILDING_FUNCTION_MARKETCART_FISH",
	Name = "BUILDING_FUNCTION_MARKETCART_FISH_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "MARKET_TENDER", 
        Behavior = "BEHAVIOR_WORK"
    },
	TypeList = { "RESOURCE_TYPE_FISH" },
	IsOverrideCapacity = true,
	CapacityPerSlot = 50,
	InputInventoryCapacity = {
		{ Resource = "FISH", Quantity = 50 },
	},
    ResourceListNeeded = {
		{ Resource = "FISH", Quantity = 10 },
	},
	ResourceProduced = {
		{ Resource = "FISH", Quantity = 10 },
	}
})



-- Building Function: Honey Cart -------------------------------------------------------------------------------------
mod:registerEnumValue( "RESOURCE_TYPE", "RESOURCE_TYPE_HONEY" )
mod:override({ Id = "HONEY", ResourceTypeList = { "RESOURCE_FOOD", "FOOD", "RESOURCE_TYPE_HONEY" } })
mod:register({
    DataType = "BUILDING_FUNCTION_MARKET",
    Id = "BUILDING_FUNCTION_MARKETCART_HONEY",
	Name = "BUILDING_FUNCTION_MARKETCART_HONEY_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "MARKET_TENDER", 
        Behavior = "BEHAVIOR_WORK"
    },
	TypeList = { "RESOURCE_TYPE_HONEY" },
	IsOverrideCapacity = true,
	CapacityPerSlot = 50,
	InputInventoryCapacity = {
		{ Resource = "HONEY", Quantity = 50 },
	},
    ResourceListNeeded = {
		{ Resource = "HONEY", Quantity = 10 },
	},
	ResourceProduced = {
		{ Resource = "HONEY", Quantity = 10 },
	}
})